import unittest
from unittest.mock import Mock, patch, call, MagicMock
from app.players.player import Players


class TestPlayer(unittest.TestCase):
    @patch('app.players.player.input')
    def test_player_1_shot_must_return_true(self, mock_input):
        mock_input.return_value = 'B1'
        matrix = [[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']],
                  [['B1'], ['Aircraft Carrier'], ['Aircraft Carrier'], ['Aircraft Carrier'], ['Aircraft Carrier'],
                   ['B6'], ['B7'], ['B8'], ['B9'], ['B10']],
                  [['C1'], ['C2'], ['C3'], ['C4'], ['C5'], ['C6'], ['C7'], ['C8'], ['C9'], ['C10']],
                  [['D1'], ['D2'], ['D3'], ['D4'], ['D5'], ['D6'], ['D7'], ['D8'], ['D9'], ['D10']],
                  [['E1'], ['E2'], ['E3'], ['E4'], ['E5'], ['E6'], ['E7'], ['E8'], ['E9'], ['E10']],
                  [['F1'], ['F2'], ['F3'], ['F4'], ['F5'], ['F6'], ['F7'], ['F8'], ['F9'], ['F10']],
                  [['G1'], ['G2'], ['G3'], ['G4'], ['G5'], ['G6'], ['G7'], ['G8'], ['G9'], ['G10']],
                  [['H1'], ['H2'], ['H3'], ['H4'], ['H5'], ['H6'], ['H7'], ['H8'], ['H9'], ['H10']],
                  [['I1'], ['I2'], ['I3'], ['I4'], ['I5'], ['I6'], ['I7'], ['I8'], ['I9'], ['I10']],
                  [['J1'], ['J2'], ['J3'], ['J4'], ['J5'], ['J6'], ['J7'], ['J8'], ['J9'], ['J10']]]
        vessel2 = ['B1', 'Battleship', 'Cruiser',
                   'Destroyer', 'Destroyer', 'Submarines', 'Submarines']

        matrix2 = [[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']],
                   [['B1'], ['Aircraft Carrier'], ['Aircraft Carrier'], ['Aircraft Carrier'], ['Aircraft Carrier'],
                    ['B6'], ['B7'], ['B8'], ['B9'], ['B10']],
                   [['C1'], ['C2'], ['C3'], ['C4'], ['C5'], ['C6'], ['C7'], ['C8'], ['C9'], ['C10']],
                   [['D1'], ['D2'], ['D3'], ['D4'], ['D5'], ['D6'], ['D7'], ['D8'], ['D9'], ['D10']],
                   [['E1'], ['E2'], ['E3'], ['E4'], ['E5'], ['E6'], ['E7'], ['E8'], ['E9'], ['E10']],
                   [['F1'], ['F2'], ['F3'], ['F4'], ['F5'], ['F6'], ['F7'], ['F8'], ['F9'], ['F10']],
                   [['G1'], ['G2'], ['G3'], ['G4'], ['G5'], ['G6'], ['G7'], ['G8'], ['G9'], ['G10']],
                   [['H1'], ['H2'], ['H3'], ['H4'], ['H5'], ['H6'], ['H7'], ['H8'], ['H9'], ['H10']],
                   [['I1'], ['I2'], ['I3'], ['I4'], ['I5'], ['I6'], ['I7'], ['I8'], ['I9'], ['I10']],
                   [['J1'], ['J2'], ['J3'], ['J4'], ['J5'], ['J6'], ['J7'], ['J8'], ['J9'], ['J10']]]

        player1 = 'Gab'

        players = Players(matrix, Mock(), vessel2, Mock(), matrix2, player1, Mock())

        self.assertTrue(players.player_1())
        self.assertEqual([[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']],
                          [['💥'], ['Aircraft Carrier'], ['Aircraft Carrier'], ['Aircraft Carrier'],
                           ['Aircraft Carrier'], ['B6'], ['B7'], ['B8'], ['B9'], ['B10']],
                          [['C1'], ['C2'], ['C3'], ['C4'], ['C5'], ['C6'], ['C7'], ['C8'], ['C9'], ['C10']],
                          [['D1'], ['D2'], ['D3'], ['D4'], ['D5'], ['D6'], ['D7'], ['D8'], ['D9'], ['D10']],
                          [['E1'], ['E2'], ['E3'], ['E4'], ['E5'], ['E6'], ['E7'], ['E8'], ['E9'], ['E10']],
                          [['F1'], ['F2'], ['F3'], ['F4'], ['F5'], ['F6'], ['F7'], ['F8'], ['F9'], ['F10']],
                          [['G1'], ['G2'], ['G3'], ['G4'], ['G5'], ['G6'], ['G7'], ['G8'], ['G9'], ['G10']],
                          [['H1'], ['H2'], ['H3'], ['H4'], ['H5'], ['H6'], ['H7'], ['H8'], ['H9'], ['H10']],
                          [['I1'], ['I2'], ['I3'], ['I4'], ['I5'], ['I6'], ['I7'], ['I8'], ['I9'], ['I10']],
                          [['J1'], ['J2'], ['J3'], ['J4'], ['J5'], ['J6'], ['J7'], ['J8'], ['J9'], ['J10']]], matrix2)

        mock_input.called_once_with(f'Move {player1}\n>> ')

    @patch('app.players.player.input')
    def test_player_2(self, mock_input):
        mock_input.return_value = 'C3'

        matrix = [[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']],
                  [['B1'], ['B2'], ['B3'], ['B4'], ['B5'], ['B6'], ['B7'], ['B8'], ['B9'], ['B10']],
                  [['C1'], ['Battleship'], ['C3'], ['Battleship'], ['Battleship'], ['C6'], ['C7'], ['C8'], ['C9'],
                   ['C10']],
                  [['D1'], ['D2'], ['D3'], ['D4'], ['D5'], ['D6'], ['D7'], ['D8'], ['D9'], ['D10']],
                  [['E1'], ['E2'], ['E3'], ['E4'], ['E5'], ['E6'], ['E7'], ['E8'], ['E9'], ['E10']],
                  [['F1'], ['F2'], ['F3'], ['F4'], ['F5'], ['F6'], ['F7'], ['F8'], ['F9'], ['F10']],
                  [['G1'], ['G2'], ['G3'], ['G4'], ['G5'], ['G6'], ['G7'], ['G8'], ['G9'], ['G10']],
                  [['H1'], ['H2'], ['H3'], ['H4'], ['H5'], ['H6'], ['H7'], ['H8'], ['H9'], ['H10']],
                  [['I1'], ['I2'], ['I3'], ['I4'], ['I5'], ['I6'], ['I7'], ['I8'], ['I9'], ['I10']],
                  [['J1'], ['J2'], ['J3'], ['J4'], ['J5'], ['J6'], ['J7'], ['J8'], ['J9'], ['J10']]]
        vessel1 = ['Aircraft Carrier', 'C3', 'Cruiser',
                   'Destroyer', 'Destroyer', 'Submarines', 'Submarines']
        matrix1 = [[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']],
                   [['B1'], ['B2'], ['B3'], ['B4'], ['B5'], ['B6'], ['B7'], ['B8'], ['B9'], ['B10']],
                   [['C1'], ['Battleship'], ['C3'], ['Battleship'], ['Battleship'], ['C6'], ['C7'], ['C8'], ['C9'],
                    ['C10']],
                   [['D1'], ['D2'], ['D3'], ['D4'], ['D5'], ['D6'], ['D7'], ['D8'], ['D9'], ['D10']],
                   [['E1'], ['E2'], ['E3'], ['E4'], ['E5'], ['E6'], ['E7'], ['E8'], ['E9'], ['E10']],
                   [['F1'], ['F2'], ['F3'], ['F4'], ['F5'], ['F6'], ['F7'], ['F8'], ['F9'], ['F10']],
                   [['G1'], ['G2'], ['G3'], ['G4'], ['G5'], ['G6'], ['G7'], ['G8'], ['G9'], ['G10']],
                   [['H1'], ['H2'], ['H3'], ['H4'], ['H5'], ['H6'], ['H7'], ['H8'], ['H9'], ['H10']],
                   [['I1'], ['I2'], ['I3'], ['I4'], ['I5'], ['I6'], ['I7'], ['I8'], ['I9'], ['I10']],
                   [['J1'], ['J2'], ['J3'], ['J4'], ['J5'], ['J6'], ['J7'], ['J8'], ['J9'], ['J10']]]

        player2 = 'Joao'

        players = Players(matrix, vessel1, Mock(), matrix1, Mock(), Mock(), player2)

        self.assertTrue(players.player_2())
        self.assertEqual([[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']],
                          [['B1'], ['B2'], ['B3'], ['B4'], ['B5'], ['B6'], ['B7'], ['B8'], ['B9'], ['B10']],
                          [['C1'], ['Battleship'], ['💥'], ['Battleship'], ['Battleship'], ['C6'], ['C7'], ['C8'],
                           ['C9'], ['C10']],
                          [['D1'], ['D2'], ['D3'], ['D4'], ['D5'], ['D6'], ['D7'], ['D8'], ['D9'], ['D10']],
                          [['E1'], ['E2'], ['E3'], ['E4'], ['E5'], ['E6'], ['E7'], ['E8'], ['E9'], ['E10']],
                          [['F1'], ['F2'], ['F3'], ['F4'], ['F5'], ['F6'], ['F7'], ['F8'], ['F9'], ['F10']],
                          [['G1'], ['G2'], ['G3'], ['G4'], ['G5'], ['G6'], ['G7'], ['G8'], ['G9'], ['G10']],
                          [['H1'], ['H2'], ['H3'], ['H4'], ['H5'], ['H6'], ['H7'], ['H8'], ['H9'], ['H10']],
                          [['I1'], ['I2'], ['I3'], ['I4'], ['I5'], ['I6'], ['I7'], ['I8'], ['I9'], ['I10']],
                          [['J1'], ['J2'], ['J3'], ['J4'], ['J5'], ['J6'], ['J7'], ['J8'], ['J9'], ['J10']]], matrix1)

        mock_input.called_once_with(f'Move {player2}\n>> ')
